"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.httpHeaderNormalizer = void 0;
var tslib_1 = require("tslib");
var compose_1 = require("@lambda-middleware/compose");
var logger_1 = require("./logger");
function lowercaseKeys(object) {
    var newObject = {};
    for (var key in object) {
        newObject[key.toLowerCase()] = object[key];
    }
    return newObject;
}
function addReferrer(headers) {
    var _a, _b;
    return tslib_1.__assign(tslib_1.__assign({}, headers), { referrer: (_a = headers.referrer) !== null && _a !== void 0 ? _a : headers.referer, referer: (_b = headers.referer) !== null && _b !== void 0 ? _b : headers.referrer });
}
function normalizeHeaders(headers) {
    return compose_1.compose(addReferrer, lowercaseKeys)(headers);
}
exports.httpHeaderNormalizer = function () { return function (handler) { return function (event, context) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
    var normalizedEvent;
    return tslib_1.__generator(this, function (_a) {
        logger_1.logger("Running handler");
        normalizedEvent = tslib_1.__assign(tslib_1.__assign({}, event), { headers: normalizeHeaders(event.headers), rawHeaders: event.headers });
        return [2 /*return*/, handler(normalizedEvent, context)];
    });
}); }; }; };
//# sourceMappingURL=http-header-normalizer.js.map